<template>
  <div>
    <ob-table
        :columns="columns"
        :items="spotTableItems"
        :remote-trigger="spotClientFilter"
        :functional-panel="true"
        :is-functional-sort="false"
        :is-functional-group="false"
        :loading="loadingData"
        @onCheckAll="onCheckAll"
        @onChangePage="onChangePage"
        @select="onSelectTableRow"
        :show-header-checkbox='showCheckbox'
    >
      <template  v-if="$route.name === 'spot__list_draft'" v-slot:extraFuncButtons>
        <div v-if="checkedItems.length > 0" class="checked-counter">
          <span>
            Выбрано: {{checkedItems.length}} записи
          </span>
          <ob-button
              label="Опубликовать"
              @click="onOpenModal('confirm')"
          />
          <span class="delete disabled">
            Удалить
          </span>
        </div>
      </template>
      <template
          v-if="$route.name === 'spot__list_draft'"
          v-slot:extraFuncToPanel
      >
        <ob-tooltip content="Загрузить спот-аукционы из Excel">
          <i
            class="icon excel"
            @click="onOpenModal('excel')"
          />
        </ob-tooltip>
      </template>
      <template v-if="$route.name === 'spot__list_draft'" v-slot:checkbox="{ data }">
        <div
            @mousemove="isHover = true"
            @mouseleave="isHover = false"
        >
          <ob-checkbox
              v-model="data.item.checked"
              @change="onCheck(data.item)"
          />
        </div>
      </template>
      <template #notification="{data}">
        <notificationSlot :item="data.item" />
      </template>
      <template #draftLifetime="{data}">
        <draftLifetimeSlot :item="data.item" />
      </template>
      <template #route="{data}">
        <routeSlot :item="data.item" />
      </template>
      <template #fromDt="{data}">
        <dateFromSlot :item="data.item" />
      </template>
      <template #auctionType="{data}">
        <auctionTypeSlot :item="data.item" />
      </template>
      <template #currentPrice="{data}">
        <currentPriceSlot :item="data.item" />
      </template>
      <template #leadPartner="{data}">
        <leadPartnerSlot :item="data.item" />
      </template>
      <template #status="{data}">
        <statusSlot
          :item="data.item"
          :type-auction="urlMap[$route.name].tab"
          @copy="onCopyItemInfo(data.item)"
          @remove="onOpenModal('remove', data.item)"
        />
      </template>
    </ob-table>
    <ob-modal
        ref="commonModal"
        :data-qa="typeModal"
        :title="modal[typeModal].title"
        :is-show-controls="modal[typeModal].controls"
        :is-error="modal[typeModal].isError"
        :size="modal[typeModal].size"
        :is-confirm="true"
        :ok-text="modal[typeModal].okText"
        :cancel-text="modal[typeModal].cancelText"
        @submit="modal[typeModal].methods()"
        @close="onCloseModal"
    >
<!--      :str-confirm-modal-title="'Закрыть без сохранения?'"-->
      <excel-modal
        ref="excelModal"
        v-if="typeModal === 'excel'"
        @close="onDownloadExcel"
      />
      <confirm-modal
          ref="confirmModal"
          :items="checkedItems"
          v-if="typeModal === 'confirm'"
          @close="onCloseModal"
      />
      <p v-if="typeModal === 'remove'">Вы уверены, что хотите удалить черновик?</p>
    </ob-modal>
  </div>
</template>

<script>
import api from '@/api';
import { uuid } from 'vue-uuid';
import {mapGetters, mapMutations} from 'vuex';
import ObTable from 'common-components/src/obComponents/obTable';
import ObButton from 'common-components/src/obComponents/obButton';
import ObCheckbox from 'common-components/src/obComponents/obCheckbox';
import ObTooltip from 'common-components/src/obComponents/obTooltip';
import ObModal from 'common-components/src/obComponents/obModal';
import routeSlot from './slots/route';
import dateFromSlot from './slots/dateFrom';
import notificationSlot from './slots/notification';
import draftLifetimeSlot from './slots/draftLifetime';
import auctionTypeSlot from './slots/auctionType';
import currentPriceSlot from './slots/currentPrice';
import leadPartnerSlot from './slots/leadPartner';
import statusSlot from './slots/status';
import ExcelModal from './components/ExcelModal';
import ConfirmModal from './components/ConfirmModal';

export default {
  name: 'spotListTable',
  components: {
    ObTable,
    ObCheckbox,
    ObButton,
    ObTooltip,
    ObModal,
    routeSlot,
    dateFromSlot,
    notificationSlot,
    draftLifetimeSlot,
    auctionTypeSlot,
    currentPriceSlot,
    leadPartnerSlot,
    statusSlot,
    ExcelModal,
    ConfirmModal
  },
  props: {
    tableHeight: {
      type: Number,
      default: 300
    },
    columns: {
      type: Array,
      default: () => []
    }
  },
  data () {
    return {
      showCheckbox:false,
      paginationPage: 1,
      isHover: false,
      isCheckAll: false,
      checkedItems: [],
      resourceType: [],
      resourceMasks: [],
      spotTableItems: [],
      loadingData: true,
      showModal: false,
      selectedItem: null,
      typeModal: 'excel',
      modal: {
        remove: {
          title: 'Удаление спота',
          isError: true,
          controls: true,
          size: 'small',
          okText: 'Удалить',
          cancelText: 'Отмена',
          methods: this.onRemoveItem
        },
        excel: {
          title: 'Загрузить спот-аукционы из Excel',
          isError: false,
          controls: false,
          size: 'medium'
        },
        confirm: {
          title: 'Опубликовать спот-аукционы',
          isError: false,
          controls: false,
          size: 'small',
          okText: 'Опубликовать',
          cancelText: 'Отмена',
        }
      }
    }
  },
  computed: {
    ...mapGetters({
      spotClientFilter: 'spot/clientFilter',
      urlMap: 'spot/urlMap'
    })
  },
  updated() {
    this.showCheckbox = this.isShowHeaderCheckbox()
  },
  created() {
    this.getSpotListByTab({
      tabType: this.urlMap[this.$route.name].tab
    })
  },
  methods: {
    ...mapMutations({
      setSpotNumber: 'spot/SET_SPOT_NUMBER',
      setSpotClientFilterLoader: 'spot/SET_SPOT_CLIENT_FILTER_LOADER'
    }),
    async getSpotListByTab ({ tabType }) {
      this.loadingData = true;
      const postData = {
        tabType: this.urlMap[this.$route.name].tab,
        sortField: 'updated_at',
        sortDirection: 'desc',
        ...this.spotClientFilter
      };

      try {
        const spotList = await api.spotAuction.getSpotListByTab({ postData });

        const auctionsUuidList = new Set(spotList.content.map(item => item.auctionUuid));

        let auctionsList = await api.spotAuction.getAuctionInfoSimple({ list: [...auctionsUuidList] });

        this.setSpotClientFilterLoader(false);

        this.spotTableItems = this.preprocessTableData(spotList.content, auctionsList.list, tabType);
        if (this.spotClientFilter.auctionType) {
          this.spotTableItems.filter(item => item.auctionType === this.spotClientFilter.auctionType)
        }

        this.spotTableItems.forEach(value => {
          value.checked = this.isCheckAll
        });

        this.loadingData = false;
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },
    preprocessTableData (spot, auction, typeOrder = undefined) {
      const auctionHash = auction.reduce((acc, item) => {
        acc[item.auctionUuid] = item;
        return acc
      }, {});

      return spot.map((item) => {
        if (auctionHash.hasOwnProperty(item.auctionUuid)) {

          let tmpItem = {
            ...item,
            auctionStatus: auctionHash[item.auctionUuid].auctionStatus,
            auctionType: auctionHash[item.auctionUuid].type,
            duration: auctionHash[item.auctionUuid].duration,
            endPlanDt: auctionHash[item.auctionUuid].endPlanDt,
            startPlanDt: auctionHash[item.auctionUuid].startPlanDt
          };

          if (typeOrder === 'draft') {
            tmpItem = {
              ...tmpItem,
              currentPrice: auctionHash[item.auctionUuid].startPrice
            }
          }

          return tmpItem
        } else {
          return item
        }
      })
    },
    onCopyItemInfo (row) {
      let notificationId = new Date().getTime() + '_copy';
      this.$notification({
        type: 'system_notification_in_load',
        message: 'Копировать',
        id: notificationId
      });
      setTimeout(() => {
        this.$notification({ event: 'close', id: notificationId })
      }, 1000);
      this.$router.push({ name: 'spot__draft__item__final', params: { uuid: uuid.v4(), id: 'created', rowUuid: row.uuid } })
    },
    onSelectTableRow (row) {
      if(!this.isHover){
        if (this.$route.name === 'spot__list_draft') {
          this.$router.push({ name: 'spot__draft__item__final', params: { uuid: row.uuid } });
          this.setSpotNumber(row.number)
        }
        if (this.$route.name === 'spot__list_completed') {
          this.$router.push({ name: 'spot__item', params: { uuid: row.uuid, status: row.orderStatus } })
        }
      }
    },
    onOpenModal (type, row) {
      this.typeModal = type;
      this.selectedItem = row || null;
      this.$refs.commonModal.open();
    },
    onDownloadExcel () {
      this.$refs.commonModal.close();
    },
    onRemoveItem () {
      api.spotAuction.removeSpotByUuid(this.selectedItem.uuid)
         .then(() => {
           this.getSpotListByTab({
             tabType: this.urlMap[this.$route.name].tab
           })
         })
         .catch(() => {
           this.$notification({
             type: 'system_notification_error',
             message: 'Ошибка при удалении'
           });
         })
         .finally(() => {
           this.$refs.commonModal.close();
         });
    },
    onCloseModal () {
      if (this.typeModal === 'excel') {
        this.$refs.excelModal.clear();
      }
      else if (this.typeModal === 'confirm') {
        this.showCheckbox = false;
        this.isCheckAll = false;
        this.checkedItems = [];
        this.$refs.commonModal.close();
        this.getSpotListByTab({
          tabType: this.urlMap[this.$route.name].tab
        })
      }
    },
    /* isCorrect() {
       let errorItems = [];
       errorItems = this.checkedItems.filter(value =>{
         return value.fromDt === null
             || value.fromLocation === null
             || value.resourceTypeTitle === null
             || value.toLocation === null
       })
       this.isDisabled = errorItems.length > 0
     },*/
    isShowHeaderCheckbox(){
      return this.$route.name === 'spot__list_draft'
    },
    onCheck (item) {
      this.showCheckbox = false;
      this.isCheckAll = false;
      if(item.checked) {
        this.checkedItems.push(item);
      }
      else {
        this.checkedItems.forEach((value, key) => {
          if(value.uuid === item.uuid) {
            this.checkedItems.splice(key,1)
          }
        })
      }
      // this.isCorrect()
    },
    onChangePage (page) {
      this.showCheckbox = false
      this.isCheckAll = false;
      this.paginationPage = page + 1;
      this.checkedItems = [];
      this.spotTableItems.forEach((value, index) => {
        if (index < this.paginationPage * 50 && index >= (this.paginationPage - 1) * 50) {
          value.checked = false
        }
      })
    },
    onCheckAll () {
      this.checkedItems = []
      if (!this.isCheckAll) {
        let _data = []
        this.spotTableItems.forEach((value, index)=>{
          if(index < this.paginationPage * 50 && index >= (this.paginationPage-1) * 50){
            value.checked = true
            this.checkedItems.push(value)
          } else {
            value.checked = false
          }
          _data.push(value)
        })
        this.spotTableItems =_data

      }
      else {
        this.spotTableItems = this.spotTableItems.map(item => {
          item.checked = false
          return item
        })
      }
      this.isCheckAll = !this.isCheckAll
      // this.isCorrect()
    }
  }
}
</script>
<style scoped lang="scss">
  .checked-counter{
    display: flex;
    align-items: center;
    span{
      margin-right: 20px;
      &.delete{
        margin-left: 25px;
        color: $color-error;
        &.disabled{
          color: $obFuncPanel-control_input_color;
        }
      }
    }
  }
</style>